## Xalan-C++ API Documentation

### The Xalan C++ XSLT Processor Version 1.9

Main Page | Class Hierarchy | Alphabetical List | Class List | File List | Class Members | File Members | Related Pages

# DOMStringHelper.hpp File Reference

Include dependency graph for DOMStringHelper.hpp:

This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Classes

- class DOMStringHelper
- struct c_wstr_functor
- struct DOMStringHashFunction
    Hash functor for DOMStrings. More...
- struct XalanMapKeyTraits< XalanDOMString >
- struct DOMStringPointerHashFunction
    Hash functor for DOMStrings. More...
- struct XalanMapKeyTraits< XalanDOMString * >
- struct XalanMapKeyTraits< const XalanDOMString * >
- struct DOMStringEqualsFunction
    Equals functor for DOMStrings. More...
- struct DOMStringNotEqualsFunction
    Not equals functor for DOMStrings. More...
- struct DOMStringLessThanFunction
    Less than functor for DOMStrings. More...
- struct DOMStringPointerEqualToFunction
    Equal to functor for DOMStrings. More...
- struct DOMStringPointerLessThanFunction
    Less than functor for DOMStrings. More...
- struct DOMStringLessThanIgnoreCaseASCIIFunction
    Less than functor for DOMStrings which ignores case for the characters a-z and A-Z. More...
- struct DOMStringLessThanOrEqualFunction
    Less than or equal functor for DOMStrings. More...
- struct DOMStringGreaterThanFunction
    Greater than functor for DOMStrings. More...
- struct DOMStringGreaterThanOrEqualFunction
    Greater than or equal functor for DOMStrings. More...
- struct less_no_case_ascii_wide_string
    This functor is designed to compare 0-terminated wide strings in a case-insensitive manner. More...

## Defines

- #define DOMSTRINGHELPER_HEADER_GUARD_1357924680
- #define XALAN_STATIC_UCODE_STRING(str) str

## Functions

- const XalanDOMString & StaticStringToDOMString (const XalanDOMString &theString)
- template<class InputIteratorType, class OutputIteratorType> OutputIteratorType XalanCopy (InputIteratorType begin, InputIteratorType end, OutputIteratorType iterator)
- template<class InputIteratorType, class OutputIteratorType, class UnaryFunction> OutputIteratorType XalanTransform (InputIteratorType begin, InputIteratorType end, OutputIteratorType iterator, UnaryFunction function)
- const XalanDOMChar * c_wstr (const XalanDOMString &theString)
    Get the underlying representation of the target XalanDOMString as a null-terminated string.
- const char * c_str (const CharVectorType &theString)
    Get the underlying representation of the target CharVectorType as a null-terminated string.
- const XalanDOMChar * c_wstr (const XalanDOMChar *theString)
    Get the underlying representation of the wide string as a UNICODE null-terminated string.
- const XalanDOMChar * toCharArray (const XalanDOMString &theString)
    Get the underlying representation of the target XalanDOMString as an array of XalanDOMChar, not guaranteed to be null-terminated.
- const XalanDOMChar * toCharArray (const XalanDOMChar *theString)
    Get the underlying representation of a XalanDOMChar.
- const char * toCharArray (const CharVectorType &theString)
    Get the underlying representation of the target CharVectorType as a pointer to an array of characters.
- void reserve (XalanDOMString &theString, XalanDOMString::size_type theCount)
    Reserve some space in the string for more efficient concatenation...
- XalanDOMString::size_type length (const XalanDOMString &theString)
    Get the length of a XalanDOMString.
- XalanDOMString::size_type length (const XalanDOMChar *theString)
    Get the length of a null-terminated string of XalanDOMChar characters.
- XalanDOMString::size_type length (const char *theString)
    Get the length of a null-terminated string.
- bool isEmpty (const XalanDOMString &str)
    Determines if the target string contains any elements.
- XalanDOMString::size_type indexOf (const XalanDOMChar *theString, XalanDOMChar theChar)
    Simulates the java String method indexOf().
- XalanDOMString::size_type indexOf (const XalanDOMChar *theString, XalanDOMString::size_type theStringLength, XalanDOMChar theChar)
    Simulates the java String method indexOf().
- XalanDOMString::size_type indexOf (const XalanDOMString &theString, XalanDOMChar theChar)
    Simulates the java String method indexOf().
- indexOf (const XalanDOMChar *theString, XalanDOMString::size_type theStringLength, const XalanDOMChar *theSubstring, XalanDOMString::size_type theSubstringLength)
    Simulates the java String method indexOf().
- indexOf (const XalanDOMChar *theString, const XalanDOMChar *theSubstring)
    Simulates the java String method indexOf().
- indexOf (const XalanDOMString &theString, const XalanDOMString &theSubstring)
    Simulates the java String method indexOf().
- lastIndexOf (const XalanDOMChar *theString, XalanDOMChar theChar)
    Simulates the java String method lastIndexOf().
- XalanDOMString::size_type lastIndexOf (const XalanDOMString &theString, XalanDOMChar theChar)
    Simulates the java String method lastIndexOf().
- startsWith (const XalanDOMChar *theString, XalanDOMString::size_type theStringLength, const XalanDOMChar *theSubstring, XalanDOMString::size_type theSubstringLength)
    Simulates the java String method startsWith().
- bool startsWith (const XalanDOMChar *theString, const XalanDOMChar *theSubstring)
    Simulates the java String method startsWith().
- bool startsWith (const XalanDOMChar *theString, const XalanDOMString &theSubstring)
    Simulates the java String method startsWith().
- bool startsWith (const XalanDOMString &theString, const XalanDOMChar *theSubstring)
    Simulates the java String method startsWith().
- bool startsWith (const XalanDOMString &theString, const XalanDOMChar *theSubstring, XalanDOMString::size_type theSubstringLength)
    Simulates the java String method startsWith().
- bool startsWith (const XalanDOMString &theString, const XalanDOMString &theSubstring)
    Simulates the java String method startsWith().
- endsWith (const XalanDOMChar *theString, XalanDOMString::size_type theStringLength, const XalanDOMChar *theSubstring, XalanDOMString::size_type theSubstringLength)
    Simulates the java String method endsWith().
- bool endsWith (const XalanDOMChar *theString, const XalanDOMChar *theSubstring)
    Simulates the java String method endsWith().
- bool endsWith (const XalanDOMString &theString, const XalanDOMString &theSubstring)
    Simulates the java String method endsWith().
- PointerToDOMString (const void *theValue, XalanDOMString &theResult)
    Converts a pointer into a XalanDOMString.
- DoubleToDOMString (double theValue, XalanDOMString &theResult)
    Converts a double value into a XalanDOMString.
- LongToHexDOMString (long theValue, XalanDOMString &theResult)
    Converts a long value into a XalanDOMString.
- UnsignedLongToHexDOMString (unsigned long theValue, XalanDOMString &theResult)
    Converts an unsigned long value and appends the result to a XalanDOMString.
- LongToDOMString (long theValue, XalanDOMString &theResult)
    Converts a long value into a XalanDOMString.
- UnsignedLongToDOMString (unsigned long theValue, XalanDOMString &theResult)
    Converts an unsigned long value and appends the result to a XalanDOMString.
- WideStringToInt (const XalanDOMChar *theString)
    Converts a wide string into an integer value.
- WideStringToLong (const XalanDOMChar *theString)
    Converts a wide string into a long value.
- WideStringToUnsignedLong (const XalanDOMChar *theString)
    Converts a wide string into an unsigned long value.
- WideStringToDouble (const XalanDOMChar *theString, MemoryManagerType &theManager)
    Converts a wide string into a double value.
- int DOMStringToInt (const XalanDOMString &theString)
    Converts a XalanDOMString into an integer value.
- long DOMStringToLong (const XalanDOMString &theString)
    Converts a XalanDOMString into a long value.
- unsigned long DOMStringToUnsignedLong (const XalanDOMString &theString)
    Converts a XalanDOMString into a long value.
- double DOMStringToDouble (const XalanDOMString &theString, MemoryManagerType &theManager)
    Converts a XalanDOMString into a double value.
- OutputString (XalanOutputStream &theStream, const CharVectorType &theString)
    Outputs the target string to the specified stream.
- OutputString (std::ostream &theStream, const CharVectorType &theString)
    Outputs the target string to the specified stream.
- OutputString (XalanOutputStream &theStream, const XalanDOMChar *theString)
    Outputs the target string to the specified stream.
- OutputString (std::ostream &theStream, const XalanDOMChar *theString)
    Outputs the target string to the specified stream.
- void OutputString (XalanOutputStream &theStream, const XalanDOMString &theString)
    Outputs the target string to the specified stream.
- void OutputString (std::ostream &theStream, const XalanDOMString &theString)
    Outputs the target string to the specified stream.
- XalanOutputStream & operator<< (XalanOutputStream &theStream, const CharVectorType &theString)
    Outputs the string to the specified stream.
- std::ostream & operator<< (std::ostream &theStream, const CharVectorType &theString)
    Outputs the string to the specified stream.
- XalanOutputStream & operator<< (XalanOutputStream &theStream, const XalanDOMChar *theString)
    Outputs the target string to the specified stream.
- std::ostream & operator<< (std::ostream &theStream, const XalanDOMChar *theString)
    Outputs the target string to the specified stream.
- XalanOutputStream & operator<< (XalanOutputStream &theStream, const XalanDOMString &theString)
    Outputs the target string to the specified stream.
- std::ostream & operator<< (std::ostream &theStream, const XalanDOMString &theString)
    Outputs the target string to the specified stream.
- XalanDOMChar charAt (const XalanDOMString &theString, XalanDOMString::size_type theIndex)
    Retrieves a character at a specified index in the target string.
- bool isXMLWhitespace (XalanDOMChar theChar)
    Determines whether character represents white space.
- bool isXMLDigit (XalanDOMChar theChar)
    Determines whether character represents a digit.
- bool isXMLLetterOrDigit (XalanDOMChar theChar)
    Determines whether character represents a letter or digit.
- substring (const XalanDOMChar *theString, XalanDOMString &theSubstring, XalanDOMString::size_type theStartIndex, XalanDOMString::size_type theEndIndex=XalanDOMString::npos)
    Simulates the java String method substring().
- substring (const XalanDOMString &theString, XalanDOMString &theSubstring, XalanDOMString::size_type theStartIndex, XalanDOMString::size_type theEndIndex=XalanDOMString::npos)
    Simulates the java String method substring().
- substring (const XalanDOMString &theString, XalanDOMString::size_type theStartIndex, XalanDOMString &theResult, XalanDOMString::size_type theEndIndex=XalanDOMString::npos)
    Simulates the java String method substring().
- XalanDOMChar toLowerASCII (XalanDOMChar theChar)
    Converts ASCII alphabetic characters from upper case to lower case.
- XalanDOMChar toUpperASCII (XalanDOMChar theChar)
    Converts ASCII alphabetic characters from lower case to upper case.
- toLowerCaseASCII (const XalanDOMChar *theString, XalanDOMString &theResult)
    Converts ASCII alphabetic characters from upper case to lower case.
- toLowerCaseASCII (const XalanDOMString &theString, XalanDOMString &theResult)
    Converts ASCII alphabetic characters from upper case to lower case.
- toUpperCaseASCII (const XalanDOMChar *theString, XalanDOMString &theResult)
    Converts ASCII alphabetic characters from lower case to upper case.
- toUpperCaseASCII (const XalanDOMString &theString, XalanDOMString &theResult)
    Converts ASCII alphabetic characters from lower case to upper case.
- compare (const CharVectorType &theLHS, const CharVectorType &theRHS)
    Compare the contents of two strings.
- compare (const XalanDOMChar *theLHS, XalanDOMString::size_type theLHSLength, const XalanDOMChar *theRHS, XalanDOMString::size_type theRHSLength)
    Compare the contents of two character arrays.
- int compare (const XalanDOMChar *theLHS, const XalanDOMChar *theRHS)
    Compare the contents of two null-terminated strings.
- int compare (const XalanDOMString &theLHS, const XalanDOMString &theRHS)
    Compare the contents of two strings.
- int compare (const XalanDOMChar *theLHS, const XalanDOMString &theRHS)
    Compare the contents of two strings.
- int compare (const XalanDOMString &theLHS, const XalanDOMChar *theRHS)
    Compare the contents of two strings.
- compareIgnoreCaseASCII (const XalanDOMChar *theLHS, XalanDOMString::size_type theLHSLength, const XalanDOMChar *theRHS, XalanDOMString::size_type theRHSLength)
    Compare the contents of two arrays in a case insensitive manner.
- int compareIgnoreCaseASCII (const XalanDOMChar *theLHS, const XalanDOMChar *theRHS)
    Compare the contents of two strings, in a case insensitive manner.
- int compareIgnoreCaseASCII (const XalanDOMString &theLHS, const XalanDOMString &theRHS)
    Compare the contents of two strings, in a case insensitive manner.
- int compareIgnoreCaseASCII (const XalanDOMString &theLHS, const XalanDOMChar *theRHS)
    Compare the contents of two strings, in a case insensitive manner.
- int compareIgnoreCaseASCII (const XalanDOMChar *theLHS, const XalanDOMString &theRHS)
    Compare the contents of two strings, in a case insensitive manner.
- collationCompare (const XalanDOMChar *theLHS, XalanDOMString::size_type theLHSLength, const XalanDOMChar *theRHS, XalanDOMString::size_type theRHSLength)
    Compare the contents of two character arrays.
- int collationCompare (const XalanDOMChar *theLHS, const XalanDOMChar *theRHS)
    Compare the contents of two strings.
- int collationCompare (const XalanDOMString &theLHS, const XalanDOMString &theRHS)
    Compare the contents of two strings.
- int collationCompare (const XalanDOMChar *theLHS, const XalanDOMString &theRHS)
    Compare the contents of two strings.
- int collationCompare (const XalanDOMString &theLHS, const XalanDOMChar *theRHS)
    Compare the contents of two strings.
- equals (const XalanDOMChar *theLHS, const XalanDOMChar *theRHS, XalanDOMString::size_type theLength)
    Compare the contents of two arrays for equality.
- bool equals (const XalanDOMChar *theLHS, XalanDOMString::size_type theLHSLength, const XalanDOMChar *theRHS, XalanDOMString::size_type theRHSLength)
    Compare the contents of two arrays for equality.
- bool equals (const XalanDOMChar *theLHS, const XalanDOMChar *theRHS)
    Compare the contents of two strings for equality.
- bool equals (const XalanDOMString &theLHS, const XalanDOMString &theRHS)
    Compare the contents of two strings for equality.
- bool equals (const XalanDOMChar *theLHS, const XalanDOMString &theRHS)
    Compare the contents of two strings for equality.
- bool equals (const XalanDOMString &theLHS, const XalanDOMChar *theRHS)
    Compare the contents of two strings for equality.
- bool equals (const XalanDOMString &theLHS, const XalanDOMChar *theRHS, XalanDOMString::size_type theRHSLength)
    Compare the contents of two strings for equality.
- equalsIgnoreCaseASCII (const XalanDOMChar *theLHS, const XalanDOMChar *theRHS, XalanDOMString::size_type theLength)
    Compare the contents of two arrays for equality, without regard for case.
- bool equalsIgnoreCaseASCII (const XalanDOMChar *theLHS, XalanDOMString::size_type theLHSLength, const XalanDOMChar *theRHS, XalanDOMString::size_type theRHSLength)
    Compare the contents of two strings for equality, without regard for case.
- bool equalsIgnoreCaseASCII (const XalanDOMChar *theLHS, const XalanDOMChar *theRHS)
    Compare the contents of two strings for equality, without regard for case.
- bool equalsIgnoreCaseASCII (const XalanDOMString &theLHS, const XalanDOMString &theRHS)
    Compare the contents of two strings for equality, without regard for case Only the characters A-Z and a-z are considered.
- bool equalsIgnoreCaseASCII (const XalanDOMChar *theLHS, const XalanDOMString &theRHS)
    Compare the contents of two strings for equality, without regard for case.
- bool equalsIgnoreCaseASCII (const XalanDOMString &theLHS, const XalanDOMChar *theRHS)
    Compare the contents of two strings for equality, without regard for case.
- bool operator< (const CharVectorType &theLHS, const CharVectorType &theRHS)
    Implements operator< for CharVectorType.
- bool operator< (const XalanDOMString &theLHS, const XalanDOMString &theRHS)
    Implements operator< for DOMStrings.
- XalanDOMString & assign (XalanDOMString &theString, const XalanDOMString &theStringToAssign)
    Assign one string to another.
- XalanDOMString & assign (XalanDOMString &theString, const XalanDOMChar *theStringToAssign, XalanDOMString::size_type theStringToAssignLength=XalanDOMString::npos)
    Assign one string to another.
- XalanDOMString & append (XalanDOMString &theString, const XalanDOMString &theStringToAppend)
    Concatenate two strings.
- XalanDOMString & append (XalanDOMString &theString, const XalanDOMChar *theStringToAppend, XalanDOMString::size_type theStringToAppendLength=XalanDOMString::npos)
    Concatenate two strings.
- XalanDOMString & append (XalanDOMString &theString, const char *theStringToAppend, XalanDOMString::size_type theStringToAppendLength=XalanDOMString::npos)
    Concatenate two strings.
- XalanDOMString & append (XalanDOMString &theString, const XalanDOMChar theCharToAppend)
    Concatenate a string and a character.
- XalanDOMString & append (XalanDOMString &theString, char theCharToAppend)
    Concatenate a string and a character.
- XalanDOMString & insert (XalanDOMString &theString, XalanDOMString::size_type thePosition, const XalanDOMString &theStringToInsert)
    Insert a string into another string.
- XalanDOMString & insert (XalanDOMString &theString, XalanDOMString::size_type thePosition, const XalanDOMChar *theStringToInsert)
    Insert a string into another string.
- trim (const XalanDOMString &theString, XalanDOMString &theResult)
    Remove trailing whitespace.
- void clear (XalanDOMString &theString)
    Remove all elements from target string.
- void erase (XalanDOMString &theString)
    Remove all elements from target string.
- void releaseMemory (XalanDOMString &theString, MemoryManagerType &theManager)
    Remove all elements from target string and frees all allocated memory.
- CopyWideStringToVector (const XalanDOMChar *theString, CharVectorType &theVector)
- CopyStringToVector (const char *theString, CharVectorType &theVector)
- MakeXalanDOMCharVector (const char *data, XalanDOMCharVectorType &result, bool fTranscode=true)
    Utility function to make a null-terminated vector of XMLChs, from a null-terminated array of chars, via transcoding, if requested.
- MakeXalanDOMCharVector (const XalanDOMChar *data, XalanDOMCharVectorType &result)
    Utility function to make a null-terminated vector of XMLChs, from a null-terminated array of XalanDOMChar.
- XalanDOMCharVectorType & MakeXalanDOMCharVector (const XalanDOMString &data, XalanDOMCharVectorType &result)
    Utility function to make a null-terminated vector of XMLChs, from a XalanDOMString.
- isXMLWhitespace (const XalanDOMString &string)
    Determines if the string contains only whitespace.
- isXMLWhitespace (const XalanDOMChar ch[], XalanDOMString::size_type start, XalanDOMString::size_type length)
    Determines if a range in an array contains only whitespace.
- bool isXMLWhitespace (const XalanDOMChar *theString)
    Determines if a null-terminated string contains only whitespace.

## Variables

- XALAN_CPP_NAMESPACE_BEGIN
  class XalanOutputStream

## Define Documentation

#define DOMSTRINGHELPER_HEADER_GUARD_1357924680

#define XALAN_STATIC_UCODE_STRING | ( | str |  | ) | str

## Function Documentation

XalanDOMString& append | ( | XalanDOMString & | theString,
|  | char | theCharToAppend
| ) |

Concatenate a string and a character.

Parameters:

  theString | target string
  theCharToAppend | the character to add to the target

Returns:
  string with the character appended

XalanDOMString& append | ( | XalanDOMString & | theString,
|  | const XalanDOMChar | theCharToAppend
| ) |

Concatenate a string and a character.

Parameters:

  theString | target string
  theCharToAppend | the character to add to the target

Returns:
  string with the character appended

XalanDOMString& append | ( | XalanDOMString & | theString,
|  | const char * | theStringToAppend,
|  | XalanDOMString::size_type | theStringToAppendLength = XalanDOMString::npos
| ) |

Concatenate two strings.

Parameters:

  theString | target string
  theStringToAppend | string to add to target
  theStringToAppendLength | length of the string (XalanDOMString::npos implies the string is null-terminated)

Returns:
  string with contents of 'theStringToAppend' added to target string

XalanDOMString& append | ( | XalanDOMString & | theString,
|  | const XalanDOMChar * | theStringToAppend,
|  | XalanDOMString::size_type | theStringToAppendLength = XalanDOMString::npos
| ) |

Concatenate two strings.

Parameters:

  theString | target string
  theStringToAppend | string to add to target
  theStringToAppendLength | length of the string (XalanDOMString::npos implies the string is null-terminated)

Returns:
  a reference to the target string

XalanDOMString& append | ( | XalanDOMString & | theString,
|  | const XalanDOMString & | theStringToAppend
| ) |

Concatenate two strings.

Parameters:

  theString | target string
  theStringToAppend | string to add to target

Returns:
  a reference to the target string

XalanDOMString& assign | ( | XalanDOMString & | theString,
|  | const XalanDOMChar * | theStringToAssign,
|  | XalanDOMString::size_type | theStringToAssignLength = XalanDOMString::npos
| ) |

Assign one string to another.

Parameters:

  theString | target string
  theStringToAppend | string to assign
  theStringToAppendLength | length of the string (XalanDOMString::npos implies the string is null-terminated)

Returns:
  a reference to the target string

XalanDOMString& assign | ( | XalanDOMString & | theString,
|  | const XalanDOMString & | theStringToAssign
| ) |

Assign one string to another.

Parameters:

  theString | target string
  theStringToAppend | string to assign
  theStringToAppendLength | length of the string (XalanDOMString::npos implies the string is null-terminated)

Returns:
  a reference to the target string

const char* c_str | ( | const CharVectorType & | theString | ) |

Get the underlying representation of the target CharVectorType as a null-terminated string.

Parameters:

  theString | target string

Returns:
  null-terminated string of chars

const XalanDOMChar* c_wstr | ( | const XalanDOMChar * | theString | ) |

Get the underlying representation of the wide string as a UNICODE null-terminated string.

This is here simply for consistency in the code. On certain platforms, compiler- generated wide strings will not contain Unicode code points. Another macro converts those into XalanDOMStrings, which are then transcoded. In these cases, the previous defined c_sstr() function gets called.

On platforms where the compiler does generate Unicode wide strings, this function will be called instead.

Parameters:

  theString | target string

Returns:
  null-terminated string of XalanDOMChar

const XalanDOMChar* c_wstr | ( | const XalanDOMString & | theString | ) |

Get the underlying representation of the target XalanDOMString as a null-terminated string.

Parameters:

  theString | target string

Returns:
  null-terminated string of XalanDOMChar

XalanDOMChar charAt | ( | const XalanDOMString & | theString,
|  | XalanDOMString::size_type | theIndex
| ) |

Retrieves a character at a specified index in the target string.

Parameters:

  theString | target string
  theIndex | index of character

Returns:
  character at specified index

void clear | ( | XalanDOMString & | theString | ) |

Remove all elements from target string.

Parameters:

  theString | target string

int collationCompare | ( | const XalanDOMString & | theLHS,
|  | const XalanDOMChar * | theRHS
| ) |

Compare the contents of two strings.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  Returns 0 for equal strings, less than 0 if theLHS is less than theRHS, or greater than 0 if theRHS is greater than theLHS.

int collationCompare | ( | const XalanDOMChar * | theLHS,
|  | const XalanDOMString & | theRHS
| ) |

Compare the contents of two strings.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  Returns 0 for equal strings, less than 0 if theLHS is less than theRHS, or greater than 0 if theRHS is greater than theLHS.

int collationCompare | ( | const XalanDOMString & | theLHS,
|  | const XalanDOMString & | theRHS
| ) |

Compare the contents of two strings.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  Returns 0 for equal strings, less than 0 if theLHS is less than theRHS, or greater than 0 if theRHS is greater than theLHS.

See also:
  operator<()

  compare()

int collationCompare | ( | const XalanDOMChar * | theLHS,
|  | const XalanDOMChar * | theRHS
| ) |

Compare the contents of two strings.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  Returns 0 for equal strings, less than 0 if theLHS is less than theRHS, or greater than 0 if theRHS is greater than theLHS.

See also:
  operator<()

  compare()

collationCompare | ( | const XalanDOMChar * | theLHS,
|  | XalanDOMString::size_type | theLHSLength,
|  | const XalanDOMChar * | theRHS,
|  | XalanDOMString::size_type | theRHSLength
| ) |

Compare the contents of two character arrays.

Parameters:

  theLHS | first array to compare
  theLHSLength | the length of the first array
  theRHS | second array to compare
  theRHSLength | the length of the second array

Returns:
  Returns 0 for equal arrays, less than 0 if theLHS is less than theRHS, or greater than 0 if theRHS is greater than theLHS.

int compare | ( | const XalanDOMString & | theLHS,
|  | const XalanDOMChar * | theRHS
| ) |

Compare the contents of two strings.

THIS FUNCTION DOES NOT COMPARE STRINGS LIKE strcmp() OR ANY OTHER "COLLATION" ALGORITHM.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  Returns 0 for equal strings, less than 0 if theLHS is less than theRHS, or greater than 0 if theRHS is greater than theLHS.

int compare | ( | const XalanDOMChar * | theLHS,
|  | const XalanDOMString & | theRHS
| ) |

Compare the contents of two strings.

THIS FUNCTION DOES NOT COMPARE STRINGS LIKE strcmp() OR ANY OTHER "COLLATION" ALGORITHM.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  Returns 0 for equal strings, less than 0 if theLHS is less than theRHS, or greater than 0 if theRHS is greater than theLHS.

int compare | ( | const XalanDOMString & | theLHS,
|  | const XalanDOMString & | theRHS
| ) |

Compare the contents of two strings.

THIS FUNCTION DOES NOT COMPARE STRINGS LIKE strcmp() OR ANY OTHER "COLLATION" ALGORITHM.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  Returns 0 for equal strings, less than 0 if theLHS is less than theRHS, or greater than 0 if theRHS is greater than theLHS.

See also:
  operator<()

  collationCompare()

int compare | ( | const XalanDOMChar * | theLHS,
|  | const XalanDOMChar * | theRHS
| ) |

Compare the contents of two null-terminated strings.

THIS FUNCTION DOES NOT COMPARE STRINGS LIKE strcmp() OR ANY OTHER "COLLATION" ALGORITHM.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  Returns 0 for equal strings, less than 0 if theLHS is less than theRHS, or greater than 0 if theRHS is greater than theLHS.

compare | ( | const XalanDOMChar * | theLHS,
|  | XalanDOMString::size_type | theLHSLength,
|  | const XalanDOMChar * | theRHS,
|  | XalanDOMString::size_type | theRHSLength
| ) |

Compare the contents of two character arrays.

THIS FUNCTION DOES NOT COMPARE STRINGS LIKE strcmp() OR ANY OTHER "COLLATION" ALGORITHM.

Parameters:

  theLHS | first array to compare
  theLHSLength | the length of the first array
  theRHS | second array to compare
  theRHSLength | the length of the second array

Returns:
  Returns 0 for equal arrays, less than 0 if theLHS is less than theRHS, or greater than 0 if theRHS is greater than theLHS.

compare | ( | const CharVectorType & | theLHS,
|  | const CharVectorType & | theRHS
| ) |

Compare the contents of two strings.

THIS FUNCTION DOES NOT COMPARE STRINGS LIKE strcmp() OR ANY OTHER "COLLATION" ALGORITHM.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  Returns 0 for equal strings, less than 0 if theLHS is less than theRHS, or greater than 0 if theRHS is greater than theLHS.

See also:
  operator<()

int compareIgnoreCaseASCII | ( | const XalanDOMChar * | theLHS,
|  | const XalanDOMString & | theRHS
| ) |

Compare the contents of two strings, in a case insensitive manner.

Only the characters a-z and A-Z are considered for the comparison.

THIS FUNCTION DOES NOT COMPARE STRINGS LIKE strcmp() OR ANY OTHER "COLLATION" ALGORITHM.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  Returns 0 for equal strings, less than 0 if theLHS is less than theRHS, or greater than 0 if theRHS is greater than theLHS.

int compareIgnoreCaseASCII | ( | const XalanDOMString & | theLHS,
|  | const XalanDOMChar * | theRHS
| ) |

Compare the contents of two strings, in a case insensitive manner.

Only the characters a-z and A-Z are considered as characters with "case".

THIS FUNCTION DOES NOT COMPARE STRINGS LIKE strcmp() OR ANY OTHER "COLLATION" ALGORITHM.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  Returns 0 for equal strings, less than 0 if theLHS is less than theRHS, or greater than 0 if theRHS is greater than theLHS.

int compareIgnoreCaseASCII | ( | const XalanDOMString & | theLHS,
|  | const XalanDOMString & | theRHS
| ) |

Compare the contents of two strings, in a case insensitive manner.

Only the characters a-z and A-Z are considered as characters with "case".

THIS FUNCTION DOES NOT COMPARE STRINGS LIKE strcmp() OR ANY OTHER "COLLATION" ALGORITHM.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  Returns 0 for equal strings, less than 0 if theLHS is less than theRHS, or greater than 0 if theRHS is greater than theLHS.

See also:
  operator<

  collationCompare

int compareIgnoreCaseASCII | ( | const XalanDOMChar * | theLHS,
|  | const XalanDOMChar * | theRHS
| ) |

Compare the contents of two strings, in a case insensitive manner.

Only the characters a-z and A-Z are considered as characters with "case".

THIS FUNCTION DOES NOT COMPARE STRINGS LIKE strcmp() OR ANY OTHER "COLLATION" ALGORITHM.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  Returns 0 for equal strings, less than 0 if theLHS is less than theRHS, or greater than 0 if theRHS is greater than theLHS.

compareIgnoreCaseASCII | ( | const XalanDOMChar * | theLHS,
|  | XalanDOMString::size_type | theLHSLength,
|  | const XalanDOMChar * | theRHS,
|  | XalanDOMString::size_type | theRHSLength
| ) |

Compare the contents of two arrays in a case insensitive manner.

Only the characters a-z and A-Z are considered as characters with "case".

THIS FUNCTION DOES NOT COMPARE STRINGS LIKE strcmp() OR ANY OTHER "COLLATION" ALGORITHM.

Parameters:

  theLHS | first array to compare
  theLHSLength | the length of the first array
  theRHS | second array to compare
  theRHSLength | the length of the second array

Returns:
  Returns 0 for equal arrays, less than 0 if theLHS is less than theRHS, or greater than 0 if theRHS is greater than theLHS.

CopyStringToVector | ( | const char * | theString,
|  | CharVectorType & | theVector
| ) |

CopyWideStringToVector | ( | const XalanDOMChar * | theString,
|  | CharVectorType & | theVector
| ) |

double DOMStringToDouble | ( | const XalanDOMString & | theString,
|  | MemoryManagerType & | theManager
| ) |

Converts a XalanDOMString into a double value.

Parameters:

  theString | target string

Returns:
  double value of target string

int DOMStringToInt | ( | const XalanDOMString & | theString | ) |

Converts a XalanDOMString into an integer value.

Parameters:

  theString | target string

Returns:
  integer value of target string

long DOMStringToLong | ( | const XalanDOMString & | theString | ) |

Converts a XalanDOMString into a long value.

Parameters:

  theString | target string

Returns:
  long value of target string

unsigned long DOMStringToUnsignedLong | ( | const XalanDOMString & | theString | ) |

Converts a XalanDOMString into a long value.

Parameters:

  theString | target string

Returns:
  unsigned long value of target string

DoubleToDOMString | ( | double | theValue,
|  | XalanDOMString & | theResult
| ) |

Converts a double value into a XalanDOMString.

Parameters:

  theValue | number to be converted
  theResult | the string to append with the result

Returns:
  a reference to the passed string result.

bool endsWith | ( | const XalanDOMString & | theString,
|  | const XalanDOMString & | theSubstring
| ) |

Simulates the java String method endsWith().

Parameters:

  theString | target string to search
  theSubstring | substring searched for

Returns:
  true if the target string ends with the substring

bool endsWith | ( | const XalanDOMChar * | theString,
|  | const XalanDOMChar * | theSubstring
| ) |

Simulates the java String method endsWith().

Parameters:

  theString | target string to search
  theSubstring | substring searched for

Returns:
  true if the target string ends with the substring

endsWith | ( | const XalanDOMChar * | theString,
|  | XalanDOMString::size_type | theStringLength,
|  | const XalanDOMChar * | theSubstring,
|  | XalanDOMString::size_type | theSubstringLength
| ) |

Simulates the java String method endsWith().

Parameters:

  theString | target string to search
  theSubstring | substring searched for

Returns:
  true if the target string ends with the substring

bool equals | ( | const XalanDOMString & | theLHS,
|  | const XalanDOMChar * | theRHS,
|  | XalanDOMString::size_type | theRHSLength
| ) |

Compare the contents of two strings for equality.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare
  theRHSLength | the length of the theRHS

Returns:
  true if the contents of both strings are identical

bool equals | ( | const XalanDOMString & | theLHS,
|  | const XalanDOMChar * | theRHS
| ) |

Compare the contents of two strings for equality.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  true if the contents of both strings are identical

bool equals | ( | const XalanDOMChar * | theLHS,
|  | const XalanDOMString & | theRHS
| ) |

Compare the contents of two strings for equality.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  true if the contents of both strings are identical

bool equals | ( | const XalanDOMString & | theLHS,
|  | const XalanDOMString & | theRHS
| ) |

Compare the contents of two strings for equality.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  true if the contents of both strings are identical

bool equals | ( | const XalanDOMChar * | theLHS,
|  | const XalanDOMChar * | theRHS
| ) |

Compare the contents of two strings for equality.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  true if the contents of both strings are identical

bool equals | ( | const XalanDOMChar * | theLHS,
|  | XalanDOMString::size_type | theLHSLength,
|  | const XalanDOMChar * | theRHS,
|  | XalanDOMString::size_type | theRHSLength
| ) |

Compare the contents of two arrays for equality.

Parameters:

  theLHS | first array to compare
  theLHSLength | the length of the theLHS
  theRHS | second array to compare
  theRHSLength | the length of the theRHS

Returns:
  true if the contents of both arrays are identical

equals | ( | const XalanDOMChar * | theLHS,
|  | const XalanDOMChar * | theRHS,
|  | XalanDOMString::size_type | theLength
| ) |

Compare the contents of two arrays for equality.

Parameters:

  theLHS | first array to compare
  theRHS | second array to compare
  theLength | the length of the arrays

Returns:
  true if the contents of both arrays are identical

bool equalsIgnoreCaseASCII | ( | const XalanDOMString & | theLHS,
|  | const XalanDOMChar * | theRHS
| ) |

Compare the contents of two strings for equality, without regard for case.

Only the characters A-Z and a-z are considered.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  true if the case-insensitive contents of both strings are identical

bool equalsIgnoreCaseASCII | ( | const XalanDOMChar * | theLHS,
|  | const XalanDOMString & | theRHS
| ) |

Compare the contents of two strings for equality, without regard for case.

Only the characters a-z and A-Z are considered characters with "case".

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  true if the case-insensitive contents of both strings are identical

bool equalsIgnoreCaseASCII | ( | const XalanDOMString & | theLHS,
|  | const XalanDOMString & | theRHS
| ) |

Compare the contents of two strings for equality, without regard for case Only the characters A-Z and a-z are considered.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  true if the case-insensitive contents of both strings are identical

bool equalsIgnoreCaseASCII | ( | const XalanDOMChar * | theLHS,
|  | const XalanDOMChar * | theRHS
| ) |

Compare the contents of two strings for equality, without regard for case.

Only the characters a-z and A-Z are considered characters with "case".

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  true if both strings are identical

bool equalsIgnoreCaseASCII | ( | const XalanDOMChar * | theLHS,
|  | XalanDOMString::size_type | theLHSLength,
|  | const XalanDOMChar * | theRHS,
|  | XalanDOMString::size_type | theRHSLength
| ) |

Compare the contents of two strings for equality, without regard for case.

Only the characters a-z and A-Z are considered characters with "case".

Parameters:

  theLHS | first string to compare
  theLHSLength | the length of the theLHS
  theRHS | second string to compare
  theRHSLength | the length of the theRHS

Returns:
  true if both strings are identical

equalsIgnoreCaseASCII | ( | const XalanDOMChar * | theLHS,
|  | const XalanDOMChar * | theRHS,
|  | XalanDOMString::size_type | theLength
| ) |

Compare the contents of two arrays for equality, without regard for case.

Only the characters a-z and A-Z are considered characters with "case".

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  true if the case-insensitive contents of both strings are identical

void erase | ( | XalanDOMString & | theString | ) |

Remove all elements from target string.

Parameters:

  theString | target string

indexOf | ( | const XalanDOMString & | theString,
|  | const XalanDOMString & | theSubstring
| ) |

Simulates the java String method indexOf().

Parameters:

  theString | string to search
  theSubstring | substring searched for

Returns:
  the index of theSubstring in theString, or length(theString) if the string is not found.

indexOf | ( | const XalanDOMChar * | theString,
|  | const XalanDOMChar * | theSubstring
| ) |

Simulates the java String method indexOf().

Parameters:

  theString | string to search
  theSubstring | substring searched for

Returns:
  the index of theSubstring in theString, or length(theString) if the string is not found.

indexOf | ( | const XalanDOMChar * | theString,
|  | XalanDOMString::size_type | theStringLength,
|  | const XalanDOMChar * | theSubstring,
|  | XalanDOMString::size_type | theSubstringLength
| ) |

Simulates the java String method indexOf().

Parameters:

  theString | string to search
  theStringLength | length of the string to search
  theSubstring | substring searched for
  theSubstringLength | length of the substring searched for

Returns:
  the index of theSubstring in theString, or length(theString) if the string is not found.

XalanDOMString::size_type indexOf | ( | const XalanDOMString & | theString,
|  | XalanDOMChar | theChar
| ) |

Simulates the java String method indexOf().

Parameters:

  theString | string to search
  theChar | character searched for

Returns:
  the index of theChar in theString, or length(theString) if the character is not found.

XalanDOMString::size_type indexOf | ( | const XalanDOMChar * | theString,
|  | XalanDOMString::size_type | theStringLength,
|  | XalanDOMChar | theChar
| ) |

Simulates the java String method indexOf().

Parameters:

  theString | string to search
  theStringLength | the length of theString
  theChar | character searched for

Returns:
  the index of theChar in theString, or length(theString) if the character is not found.

XalanDOMString::size_type indexOf | ( | const XalanDOMChar * | theString,
|  | XalanDOMChar | theChar
| ) |

Simulates the java String method indexOf().

Parameters:

  theString | string to search
  theChar | character searched for

Returns:
  the index of theChar in theString, or length(theString) if the character is not found.

XalanDOMString& insert | ( | XalanDOMString & | theString,
|  | XalanDOMString::size_type | thePosition,
|  | const XalanDOMChar * | theStringToInsert
| ) |

Insert a string into another string.

Parameters:

  theString | target string
  thePosition | The position in the target string to insert
  theStringToInsert | The string to insert

Returns:
  A reference to the target string

XalanDOMString& insert | ( | XalanDOMString & | theString,
|  | XalanDOMString::size_type | thePosition,
|  | const XalanDOMString & | theStringToInsert
| ) |

Insert a string into another string.

Parameters:

  theString | target string
  thePosition | The position in the target string to insert
  theStringToInsert | The string to insert

Returns:
  A reference to the target string

bool isEmpty | ( | const XalanDOMString & | str | ) |

Determines if the target string contains any elements.

Parameters:

  str | target string

Returns:
  true if the target string has a non-zero length

bool isXMLDigit | ( | XalanDOMChar | theChar | ) |

Determines whether character represents a digit.

Parameters:

  theChar | target character

Returns:
  true if character represents a digit

bool isXMLLetterOrDigit | ( | XalanDOMChar | theChar | ) |

Determines whether character represents a letter or digit.

Parameters:

  theChar | target character

Returns:
  true if character represents a letter or digit

bool isXMLWhitespace | ( | const XalanDOMChar * | theString | ) |

Determines if a null-terminated string contains only whitespace.

Parameters:

  theString | target string

Returns:
  true if the string contains only whitespace

isXMLWhitespace | ( | const XalanDOMChar | ch[],
|  | XalanDOMString::size_type | start,
|  | XalanDOMString::size_type | length
| ) |

Determines if a range in an array contains only whitespace.

Parameters:

  ch | target array
  start | starting index to examine
  length | number of characters to examine

Returns:
  true if specified range contains only whitespace

isXMLWhitespace | ( | const XalanDOMString & | string | ) |

Determines if the string contains only whitespace.

Parameters:

  theString | target string

Returns:
  true if string contains only whitespace

bool isXMLWhitespace | ( | XalanDOMChar | theChar | ) |

Determines whether character represents white space.

Parameters:

  theChar | target character

Returns:
  true if character represents white space

XalanDOMString::size_type lastIndexOf | ( | const XalanDOMString & | theString,
|  | XalanDOMChar | theChar
| ) |

Simulates the java String method lastIndexOf().

Parameters:

  theString | string to search
  theChar | character searched for

Returns:
  the index of theChar in theString, or length(theString) if the character is not found.

lastIndexOf | ( | const XalanDOMChar * | theString,
|  | XalanDOMChar | theChar
| ) |

Simulates the java String method lastIndexOf().

Parameters:

  theString | string to search
  theChar | character searched for

Returns:
  the index of theChar in theString, or length(theString) if the character is not found.

XalanDOMString::size_type length | ( | const char * | theString | ) |

Get the length of a null-terminated string.

Parameters:

  theString | target string

Returns:
  the length of the target string

XalanDOMString::size_type length | ( | const XalanDOMChar * | theString | ) |

Get the length of a null-terminated string of XalanDOMChar characters.

Parameters:

  theString | target string

Returns:
  the length of the target string

XalanDOMString::size_type length | ( | const XalanDOMString & | theString | ) |

Get the length of a XalanDOMString.

Parameters:

  theString | target string

Returns:
  the length of the target string

LongToDOMString | ( | long | theValue,
|  | XalanDOMString & | theResult
| ) |

Converts a long value into a XalanDOMString.

Parameters:

  theValue | number to be converted
  theResult | the string to append with the result

Returns:
  a reference to the passed string result.

LongToHexDOMString | ( | long | theValue,
|  | XalanDOMString & | theResult
| ) |

Converts a long value into a XalanDOMString.

Negative values are ignored.

Parameters:

  theValue | number to be converted
  theResult | the string to append with the result

Returns:
  a reference to the passed string result.

XalanDOMCharVectorType& MakeXalanDOMCharVector | ( | const XalanDOMString & | data,
|  | XalanDOMCharVectorType & | result
| ) |

Utility function to make a null-terminated vector of XMLChs, from a XalanDOMString.

Parameters:

  data | XalanDOMString to be converted

Returns:
  null-terminated vector of XalanDOMChar

MakeXalanDOMCharVector | ( | const XalanDOMChar * | data,
|  | XalanDOMCharVectorType & | result
| ) |

Utility function to make a null-terminated vector of XMLChs, from a null-terminated array of XalanDOMChar.

Parameters:

  data | array to be converted

Returns:
  null-terminated vector of XalanDOMChar

MakeXalanDOMCharVector | ( | const char * | data,
|  | XalanDOMCharVectorType & | result,
|  | bool | fTranscode = true
| ) |

Utility function to make a null-terminated vector of XMLChs, from a null-terminated array of chars, via transcoding, if requested.

Parameters:

  data | array to be converted
  whether | or not to transcode

Returns:
  null-terminated vector of XalanDOMChar

bool operator< | ( | const XalanDOMString & | theLHS,
|  | const XalanDOMString & | theRHS
| ) |

Implements operator< for DOMStrings.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  Returns true if theLHS is lexically less than theRHS

See also:
  compare

bool operator< | ( | const CharVectorType & | theLHS,
|  | const CharVectorType & | theRHS
| ) |

Implements operator< for CharVectorType.

Parameters:

  theLHS | first string to compare
  theRHS | second string to compare

Returns:
  Returns true if theLHS is lexically less than theRHS

See also:
  compare

std::ostream& operator<< | ( | std::ostream & | theStream,
|  | const XalanDOMString & | theString
| ) |

Outputs the target string to the specified stream.

Parameters:

  theStream | output stream
  theString | target string

See also:
  OutputString

XalanOutputStream& operator<< | ( | XalanOutputStream & | theStream,
|  | const XalanDOMString & | theString
| ) |

Outputs the target string to the specified stream.

Parameters:

  theStream | output stream
  theString | target string

See also:
  OutputString

std::ostream& operator<< | ( | std::ostream & | theStream,
|  | const XalanDOMChar * | theString
| ) |

Outputs the target string to the specified stream.

Parameters:

  theStream | output stream
  theString | target string

See also:
  OutputString

XalanOutputStream& operator<< | ( | XalanOutputStream & | theStream,
|  | const XalanDOMChar * | theString
| ) |

Outputs the target string to the specified stream.

Parameters:

  theStream | output stream
  theString | target string

See also:
  OutputString

std::ostream& operator<< | ( | std::ostream & | theStream,
|  | const CharVectorType & | theString
| ) |

Outputs the string to the specified stream.

Parameters:

  theStream | output stream
  theString | the string to output

See also:
  OutputString

XalanOutputStream& operator<< | ( | XalanOutputStream & | theStream,
|  | const CharVectorType & | theString
| ) |

Outputs the string to the specified stream.

Parameters:

  theStream | output stream
  theString | the string to output

See also:
  OutputString

void OutputString | ( | std::ostream & | theStream,
|  | const XalanDOMString & | theString
| ) |

Outputs the target string to the specified stream.

Parameters:

  theStream | output stream
  theString | target string

See also:
  operator<<

void OutputString | ( | XalanOutputStream & | theStream,
|  | const XalanDOMString & | theString
| ) |

Outputs the target string to the specified stream.

Parameters:

  theStream | output stream
  theString | target string

See also:
  operator<<

OutputString | ( | std::ostream & | theStream,
|  | const XalanDOMChar * | theString
| ) |

Outputs the target string to the specified stream.

Parameters:

  theStream | output stream
  theString | target string

See also:
  operator<<

OutputString | ( | XalanOutputStream & | theStream,
|  | const XalanDOMChar * | theString
| ) |

Outputs the target string to the specified stream.

Parameters:

  theStream | output stream
  theString | target string

See also:
  operator<<

OutputString | ( | std::ostream & | theStream,
|  | const CharVectorType & | theString
| ) |

Outputs the target string to the specified stream.

Parameters:

  theStream | output stream
  theString | target string

See also:
  operator<<

OutputString | ( | XalanOutputStream & | theStream,
|  | const CharVectorType & | theString
| ) |

Outputs the target string to the specified stream.

Parameters:

  theStream | output stream
  theString | target string

See also:
  operator<<

PointerToDOMString | ( | const void * | theValue,
|  | XalanDOMString & | theResult
| ) |

Converts a pointer into a XalanDOMString.

Parameters:

  theValue | pointer to be converted
  theResult | the string to append with the result

Returns:
  a reference to the passed string result.

void releaseMemory | ( | XalanDOMString & | theString,
|  | MemoryManagerType & | theManager
| ) |

Remove all elements from target string and frees all allocated memory.

Parameters:

  theString | target string

void reserve | ( | XalanDOMString & | theString,
|  | XalanDOMString::size_type | theCount
| ) |

Reserve some space in the string for more efficient concatenation...

Parameters:

  theString | target string
  theCount | The amount of space to reserve

bool startsWith | ( | const XalanDOMString & | theString,
|  | const XalanDOMString & | theSubstring
| ) |

Simulates the java String method startsWith().

Parameters:

  theDOMString | target string to search
  theSubstring | substring searched for

Returns:
  true if the target string begins with the substring

bool startsWith | ( | const XalanDOMString & | theString,
|  | const XalanDOMChar * | theSubstring,
|  | XalanDOMString::size_type | theSubstringLength
| ) |

Simulates the java String method startsWith().

Parameters:

  theDOMString | target string to search
  theSubstring | substring searched for
  theSubstringLength | the length of theSubstring

Returns:
  true if the target string begins with the substring

bool startsWith | ( | const XalanDOMString & | theString,
|  | const XalanDOMChar * | theSubstring
| ) |

Simulates the java String method startsWith().

Parameters:

  theDOMString | target string to search
  theSubstring | substring searched for

Returns:
  true if the target string begins with the substring

bool startsWith | ( | const XalanDOMChar * | theString,
|  | const XalanDOMString & | theSubstring
| ) |

Simulates the java String method startsWith().

Parameters:

  theDOMString | target string to search
  theSubstring | substring searched for

Returns:
  true if the target string begins with the substring

bool startsWith | ( | const XalanDOMChar * | theString,
|  | const XalanDOMChar * | theSubstring
| ) |

Simulates the java String method startsWith().

Parameters:

  theDOMString | target string to search
  theSubstring | substring searched for

Returns:
  true if the target string begins with the substring

startsWith | ( | const XalanDOMChar * | theString,
|  | XalanDOMString::size_type | theStringLength,
|  | const XalanDOMChar * | theSubstring,
|  | XalanDOMString::size_type | theSubstringLength
| ) |

Simulates the java String method startsWith().

Parameters:

  theString | target string to search
  theStringLength | the length of theString
  theSubstring | substring searched for
  theSubstringLength | the length of theSubstring

Returns:
  true if the target string begins with the substring

const XalanDOMString& StaticStringToDOMString | ( | const XalanDOMString & | theString | ) |

substring | ( | const XalanDOMString & | theString,
|  | XalanDOMString::size_type | theStartIndex,
|  | XalanDOMString & | theResult,
|  | XalanDOMString::size_type | theEndIndex = XalanDOMString::npos
| ) |

Simulates the java String method substring().

Returns a new string that is a substring of this string. The substring begins at the specified theStartIndex and extends to the character at index theEndIndex - 1. Thus the length of the substring is theEndIndex-theStartIndex.

Parameters:

  theString | source string
  theStartIndex | starting index, inclusive
  theEndIndex | ending index, exclusive

Returns:
  string containing the specified range of characters from target

substring | ( | const XalanDOMString & | theString,
|  | XalanDOMString & | theSubstring,
|  | XalanDOMString::size_type | theStartIndex,
|  | XalanDOMString::size_type | theEndIndex = XalanDOMString::npos
| ) |

Simulates the java String method substring().

Returns a new string that is a substring of this string. The substring begins at the specified theStartIndex and extends to the character at index theEndIndex - 1. Thus the length of the substring is theEndIndex - theStartIndex.

Parameters:

  theString | source string
  theSubstring | target string
  theStartIndex | starting index, inclusive
  theEndIndex | ending index, exclusive

substring | ( | const XalanDOMChar * | theString,
|  | XalanDOMString & | theSubstring,
|  | XalanDOMString::size_type | theStartIndex,
|  | XalanDOMString::size_type | theEndIndex = XalanDOMString::npos
| ) |

Simulates the java String method substring().

Returns a new string that is a substring of this string. The substring begins at the specified theStartIndex and extends to the character at index theEndIndex - 1. Thus the length of the substring is theEndIndex - theStartIndex.

Parameters:

  theString | source string
  theSubstring | target string
  theStartIndex | starting index, inclusive
  theEndIndex | ending index, exclusive

Returns:
  A reference to theSubstring

const char* toCharArray | ( | const CharVectorType & | theString | ) |

Get the underlying representation of the target CharVectorType as a pointer to an array of characters.

Parameters:

  theString | target string

Returns:
  the pointer

const XalanDOMChar* toCharArray | ( | const XalanDOMChar * | theString | ) |

Get the underlying representation of a XalanDOMChar.

Parameters:

  theString | target string

Returns:
  array of XalanDOMChar

const XalanDOMChar* toCharArray | ( | const XalanDOMString & | theString | ) |

Get the underlying representation of the target XalanDOMString as an array of XalanDOMChar, not guaranteed to be null-terminated.

Parameters:

  theString | target string

Returns:
  array of XalanDOMChar

XalanDOMChar toLowerASCII | ( | XalanDOMChar | theChar | ) |

Converts ASCII alphabetic characters from upper case to lower case.

This function works only with the Unicode characters A-Z.

Parameters:

  theString | target string

Returns:
  string containing lower case characters

toLowerCaseASCII | ( | const XalanDOMString & | theString,
|  | XalanDOMString & | theResult
| ) |

Converts ASCII alphabetic characters from upper case to lower case.

This function works only with the characters a-z and A-Z.

Parameters:

  theString | target string

Returns:
  string containing lower case characters

toLowerCaseASCII | ( | const XalanDOMChar * | theString,
|  | XalanDOMString & | theResult
| ) |

Converts ASCII alphabetic characters from upper case to lower case.

This function works only with the characters a-z and A-Z.

Parameters:

  theString | target string

Returns:
  string containing lower case characters

XalanDOMChar toUpperASCII | ( | XalanDOMChar | theChar | ) |

Converts ASCII alphabetic characters from lower case to upper case.

This function works only with the Unicode characters a-z.

Parameters:

  theString | target string

Returns:
  string containing upper case characters

toUpperCaseASCII | ( | const XalanDOMString & | theString,
|  | XalanDOMString & | theResult
| ) |

Converts ASCII alphabetic characters from lower case to upper case.

This function works only with the characters a-z and A-Z.

Parameters:

  theString | target string

Returns:
  string containing upper case characters

toUpperCaseASCII | ( | const XalanDOMChar * | theString,
|  | XalanDOMString & | theResult
| ) |

Converts ASCII alphabetic characters from lower case to upper case.

This function works only with the characters a-z and A-Z.

Parameters:

  theString | target string

Returns:
  string containing upper case characters

trim | ( | const XalanDOMString & | theString,
|  | XalanDOMString & | theResult
| ) |

Remove trailing whitespace.

Parameters:

  theString | target string

Returns:
  string with contents of target string less trailing whitespace

UnsignedLongToDOMString | ( | unsigned long | theValue,
|  | XalanDOMString & | theResult
| ) |

Converts an unsigned long value and appends the result to a XalanDOMString.

Parameters:

  theValue | number to be converted
  theResult | the string to append with the result

Returns:
  a reference to the passed string result.

UnsignedLongToHexDOMString | ( | unsigned long | theValue,
|  | XalanDOMString & | theResult
| ) |

Converts an unsigned long value and appends the result to a XalanDOMString.

Parameters:

  theValue | number to be converted
  theResult | the string to append with the result

Returns:
  a reference to the passed string result.

WideStringToDouble | ( | const XalanDOMChar * | theString,
|  | MemoryManagerType & | theManager
| ) |

Converts a wide string into a double value.

Parameters:

  theString | target string

Returns:
  double value of target string

WideStringToInt | ( | const XalanDOMChar * | theString | ) |

Converts a wide string into an integer value.

Parameters:

  theString | target string

Returns:
  integer value of target string

WideStringToLong | ( | const XalanDOMChar * | theString | ) |

Converts a wide string into a long value.

Parameters:

  theString | target string

Returns:
  long value of target string

WideStringToUnsignedLong | ( | const XalanDOMChar * | theString | ) |

Converts a wide string into an unsigned long value.

Parameters:

  theString | target string

Returns:
  unsigned long value of target string

template<class InputIteratorType, class OutputIteratorType>
OutputIteratorType XalanCopy | ( | InputIteratorType | begin,
|  | InputIteratorType | end,
|  | OutputIteratorType | iterator
| ) |

template<class InputIteratorType, class OutputIteratorType, class UnaryFunction>
OutputIteratorType XalanTransform | ( | InputIteratorType | begin,
|  | InputIteratorType | end,
|  | OutputIteratorType | iterator,
|  | UnaryFunction | function
| ) |

## Variable Documentation

XALAN_CPP_NAMESPACE_BEGIN class XalanOutputStream

Interpreting class diagrams

Doxygen and GraphViz are used to generate this API documentation from the Xalan-C header files.

Xalan-C++ XSLT Processor Version 1.9 Copyright © 1999-2004 The Apache Software Foundation. All Rights Reserved.